package com.ekingwin.eit.service.impl;

import com.ekingwin.eit.dao.IEwoPhaseRocketMqDao;
import com.ekingwin.eit.dao.ITwoPhaseRocketMqDao;
import com.ekingwin.eit.dto.TwoPhaseRocketMqDTO;
import com.ekingwin.eit.service.ITwoPhaseRocketMqService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author zugs
 */

@Service
@Primary
public class TwoPhaseRocketMqServiceImpl implements ITwoPhaseRocketMqService {
//Logger logger=

    @Autowired
    private ITwoPhaseRocketMqDao twoPhaseRocketMqDao;
    @Autowired
    private IEwoPhaseRocketMqDao ewoPhaseRocketMqDao;


//    public  List<Map<String,Object>> getTwoAllData() {
//         List<Map<String, Object>> ewoAllData = this.getEwoAllData();//EWO单子
//        List<Map<String, Object>> twoAllData = this.getTwoAllData();//TWO单子
//        return null;
//    }


    public TwoPhaseRocketMqDTO save(TwoPhaseRocketMqDTO twoPhaseRocketMqDTO) {
        return null;
    }

    public void delete(String s) {

    }

//    public PageCriteria<TwoPhaseRocketMqDTO> query(QueryDTO queryDTO) {
//        return null;
//    }

    public TwoPhaseRocketMqDTO get(String s) {
        return null;
    }


    @Override
    public  List<Map<String,Object>> getTwoAllData(){
        //先得到一天之内更新的two数据
        List<Map<String, Object>> allDatas = twoPhaseRocketMqDao.getTwoAllData();
        List<Map<String, Object>> twoInfos=new ArrayList<Map<String, Object>>();
        for ( Map<String, Object> map :allDatas ) {
            String programcodes=map.get("PROGRAMCODE")+"";
            String myids=map.get("MY")+"";
            if(StringUtils.isEmpty(myids) || StringUtils.isEmpty(programcodes)
                    || "null".equals(myids) || "null".equals(programcodes) ){
                continue;
            }
            String myname="";
            List<Map<String, Object>> myInfos = ewoPhaseRocketMqDao.getMyInfo(myids);
            if(myInfos!=null && myInfos.size()>0){
                myname=myInfos.get(0).get("MY")+"";
            }

            if(StringUtils.isNotEmpty(programcodes) && !"null".equals(programcodes)){
                //系统中是一个my对应多个programcode，现在拆开
                String[] programcodeInfos = programcodes.split(",");
                for (int i=0; i<programcodeInfos.length;i++){
                    String mynametemp=myname;
                    String programcodeid= programcodeInfos[i];
                    List<Map<String, Object>> programCodeInfo = ewoPhaseRocketMqDao.getProgramCodeInfo(programcodeid);
                    if(programCodeInfo!=null && programCodeInfo.size()>0){
                        String prgramcodename= programCodeInfo.get(0).get("PROGRAMCODE")+"";
                        Map<String, Object> twoInfo=new HashMap<String, Object>()  ;
                        twoInfo.put("twoId",map.get("TWONO")+""+myname+prgramcodename);
                        twoInfo.put("twoNo",map.get("TWONO")+"");
                        if(StringUtils.isNotEmpty(mynametemp)){
                            mynametemp=mynametemp.substring(2,mynametemp.length());
                            twoInfo.put("modelYear","MY"+mynametemp);
                        }else{
                            twoInfo.put("modelYear","");
                        }
                        //根据id查product名称
                        List<Map<String, Object>> product = new ArrayList<Map<String, Object>>();

                        if(map.get("PRODUCT")!=null && StringUtils.isNotEmpty(map.get("PRODUCT").toString())  && !"".equals(map.get("PRODUCT")+"") ){
                            product = ewoPhaseRocketMqDao.getProductInfo(map.get("PRODUCT") + "");
                        }
                        if(product!=null && product.size()>0){
                            String productName= product.get(0).get("PRODUCT")+"";
                            twoInfo.put("product",productName);
                        }else{
                            twoInfo.put("product","");
                        }
                        twoInfo.put("programCode",prgramcodename);
                        twoInfo.put("implDate",map.get("IMPLDATE")==null?"":map.get("IMPLDATE")+"");
                        String phaseAffect=map.get("PHASEAFFECT")==null?"":map.get("PHASEAFFECT")+"";
                        //对断点阶段处理
                        twoInfo= this.handlePhaseAffect(myids,programcodeid,twoInfo,phaseAffect);
                        twoInfos.add(twoInfo);
                    }
                }
            }else{
                continue;
            }
        }

        return twoInfos;
    }

    public Map<String,Object> handlePhaseAffect(String myids,String programcodeid, Map<String,Object> twoInfo,String phase){
        twoInfo.put("phaseAffect", "");
        String tid="";//TWO一个programcode可能有多个phashe阶段，取时间最小的那个
        String phaseaffect="";
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        if(StringUtils.isNotEmpty(phase) && !"null".equals(phase)){
            String[] phasedata = phase.split(",");
            for (int j=0;j<phasedata.length;j++){
                String phasedataSimpleid=phasedata[j];
                List<Map<String, Object>> PhaseaffectInfo = ewoPhaseRocketMqDao.getPhaseaffectInfo(myids, programcodeid);
                if(PhaseaffectInfo!=null && PhaseaffectInfo.size()>0){
                    String phasedataids =PhaseaffectInfo.get(0).get("NODEID")+"";
                    if(StringUtils.isNotEmpty(phasedataids)){
                        String[] split = phasedataids.split(",");
                        for (int k=0; k<split.length;k++){
                            if(phasedataSimpleid.equals(split[k])){
                                List<Map<String, Object>> phaseaffectNodeInfo = ewoPhaseRocketMqDao.getPhaseaffectNodeInfo(phasedataSimpleid);
                                if(phaseaffectNodeInfo!=null && phaseaffectNodeInfo.size()>0){
                                    Map<String, Object> map= phaseaffectNodeInfo.get(0);
                                    if(map==null){
                                        return twoInfo;
                                    }
                                    if(StringUtils.isNotEmpty(tid)){
                                        String nodeno=map.get("NODENO")==null?"":map.get("NODENO")+"";
                                        String nodetype=map.get("NODETYPE")==null?"":map.get("NODETYPE")+"";
                                        String phaseaffectTemp=nodetype+nodeno;
                                        String temptid=map.get("PHASEAFFECTDATE")==null?"":map.get("PHASEAFFECTDATE")+"";
                                        if(StringUtils.isNotEmpty(temptid) && StringUtils.isNotEmpty(tid)){
                                            try {
                                                Date tempDate= sdf.parse(temptid);
                                                Date tidDate= sdf.parse(tid);
                                                if(tidDate.after(tempDate)){
                                                    tid=temptid;
                                                    phaseaffect=phaseaffectTemp;
                                                }

                                            } catch (ParseException e) {
                                                e.printStackTrace();
                                            }
                                        }
                                    }else{
                                        tid=map.get("PHASEAFFECTDATE")==null?"":map.get("PHASEAFFECTDATE")+"";
                                        String nodeno=map.get("NODENO")==null?"":map.get("NODENO")+"";
                                        String nodetype=map.get("NODETYPE")==null?"":map.get("NODETYPE")+"";
                                        phaseaffect=nodetype+nodeno;
                                    }

                                }
                            }
                        }

                    }

                }else{
                    continue;
                }

            }
            twoInfo.put("phaseAffect",  phaseaffect);
        }else{
            twoInfo.put("phaseAffect",  "DRE RCD");
        }

        return twoInfo;
    }

}
